%{!?__python2: %global __python2 %__python}
%{!?python2_sitelib: %global python2_sitelib %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")}

%if 0%{?fedora}
%bcond_without python3
%else
%bcond_with python3
%endif

%global pkgname testinfra
%global setup_cmd_p2 SKIP_PIP_INSTALL=1 PBR_VERSION=%{version} %{__python2} setup.py
%global setup_cmd_p3 SKIP_PIP_INSTALL=1 PBR_VERSION=%{version} %{__python3} setup.py

Name:           python2-%{pkgname}
Version:        1.10.1
Release:        1%{?dist}
Summary:        Unit testing for config-managed server state

License:        ASL 2.0
URL:            https://github.com/philpep/%{pkgname}
Source0:        https://github.com/philpep/%{pkgname}/archive/%{version}.tar.gz

BuildArch:      noarch

BuildRequires:  python2-devel
BuildRequires:  python2-pbr

# testing requirements
BuildRequires:  python2-mock
BuildRequires:  python2-six
BuildRequires:  python2-pytest
BuildRequires:  python2-pytest-xdist
BuildRequires:  python2-pytest-cov
BuildRequires:  python2-winrm
BuildRequires:  python2-paramiko
BuildRequires:  salt

%if %{with python3}
BuildRequires:  python3-devel
BuildRequires:  python3-pbr

# testing requirements
BuildRequires:  python3-mock
BuildRequires:  python3-six
BuildRequires:  python3-pytest
BuildRequires:  python3-pytest-xdist
BuildRequires:  python3-pytest-cov
BuildRequires:  python3-winrm
BuildRequires:  python3-paramiko
%endif # with python3

%description
With Testinfra you can write unit tests in Python to test actual state of your
servers configured by management tools like Salt, Ansible, Puppet, Chef and so
on.

Testinfra aims to be a Serverspec equivalent in python and is written as a
plugin to the powerful Pytest test engine

%if %{with python3}
%package     -n python3-testinfra
Summary:        Unit testing for config-managed server state

%description -n python3-testinfra
With Testinfra you can write unit tests in Python to test actual state of your
servers configured by management tools like Salt, Ansible, Puppet, Chef and so
on.

Testinfra aims to be a Serverspec equivalent in python and is written as a
plugin to the powerful Pytest test engine

%endif # with python3


%prep
%autosetup -c
mv %{pkgname}-%{version} python2

%if %{with python3}
cp -a python2 python3
%endif # with python3


%build
pushd python2
%{setup_cmd_p2} build
popd

%if %{with python3}
pushd python3
%{setup_cmd_p3} build
popd
%endif # with python3


%install
rm -rf $RPM_BUILD_ROOT
# Must do the python3 install first because the scripts in /usr/bin are
# overwritten with every setup.py install (and we want the python2 version
# to be the default for now).
%if %{with python3}
pushd python3
%{setup_cmd_p3} install -O1 --skip-build --root $RPM_BUILD_ROOT
popd
%endif # with python3

pushd python2
%{setup_cmd_p2} install -O1 --skip-build --root $RPM_BUILD_ROOT
popd


%check
pushd python2
%{setup_cmd_p2} test
popd

# %if %{with python3}
# pushd python3
# %{setup_cmd_p3} test
# popd
# %endif

%files
%license python2/LICENSE
%doc python2/doc
%doc python2/*.rst
%doc python2/*-requirements.txt
%{python2_sitelib}/*
%{_bindir}/%{pkgname}

%if %{with python3}
%files -n python3-testinfra
%license python3/LICENSE
%doc python3/doc
%doc python3/*.rst
%doc python3/*-requirements.txt
%{python3_sitelib}/*
%{_bindir}/%{pkgname}
%endif # with python3


%changelog
* Wed Jan 24 2018 Brett Lentz <brett.lentz@gmail.com> - 1.10.1-1
- initial package
